/*
 * JGrowApp.java
 */

package jgrow;

import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class JGrowApp extends SingleFrameApplication {

    public JGrowView jv;
    public PanelSimulation simulationPanel;
    public InfoTiles tiles;
    public InfoBonds bonds;
    public AnimationController nip;
    public PanelInformation informationPanel;

    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
        jv = new JGrowView(this);
        show(jv);
        simulationPanel = (PanelSimulation) jv.simpan; //new PanelSimulation(false, new InfoTiles(), new InfoBonds());
        bonds = simulationPanel.nip.bonds;
        tiles = simulationPanel.nip.tiles;
        informationPanel = simulationPanel.inf;
        nip = simulationPanel.nip;
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of JGrowApp
     */
    public static JGrowApp getApplication() {
        return Application.getInstance(JGrowApp.class);
    }

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
        launch(JGrowApp.class, args);
    }
}
